import sys
import traceback
import os
import shutil

def tracebackAsString(limit):
	type, value, tb = sys.exc_info()
	aList = traceback.format_exception(type, value, tb, limit)
	formattedString = ""
	for s in aList:
		formattedString = formattedString + s + "\n"
	return formattedString

def copyTemplateDir(mgDir, userName):
	#copy MG template dir--necessary because of limitation of MG running on Windows NT/98:
	#can only create database in same directory as the executables used to create it. So,
	#for now, copy executables for each new user created.

	try:
		sourceDirName = mgDir + "templateDir"
		targetDirName = mgDir + userName

		#if path already exists, return an error; we don't want to delete the user's
		#MG database if he has one
		if os.path.exists(targetDirName):
			return ("<html><head></head><body><big><p>Directory for user already exists and "
					+ "must be deleted if desired before this program will recreate it.</p>"
					+ " <p>Deleting it will destroy your MG database.</p></big></body></html>")

		#copy source directory to target directory--will create target dir
		shutil.copytree(sourceDirName, targetDirName)

	except Exception, data:
		s = "Error copying MG templateDir for user.<br>" + tracebackAsString(20)
		return s
	return None

def addKmUser(self, REQUEST):
	try:
		acl_users_folder= self.aq_parent["acl_users"]
		name = REQUEST["name"]
		password = REQUEST["password"]
		confirm = REQUEST["confirm"]
		domains = ""
		roles = ["Authorized"]

		result = acl_users_folder._addUser(name,password,confirm,roles,domains,REQUEST)

		mgDir = self.aq_parent["mgDir"]
		result = copyTemplateDir(mgDir, name)
		if result != None:
			return result

	except Exception, data:
		return tracebackAsString(20)

	return "User added successfully!"