import sys
import string
import traceback
import socket
import time
import urllib
import re

#Make sure Extensions folder is in Zope sys.path so imports won't fail. To do so,
#find a path segment we can feel sure is Zope's. Get Zope install folder path from it.
#Use this to build an Extensions folder path segment.
extensionsFound = 0
zInstallPath = "C:\\Website\\"

for p in sys.path:
	if string.find(p, r'\lib\python\ZopeZODB') != 1:
		pathParts = string.split(p, "\\")
		zInstallParts = pathParts[:-3]
		zInstallPath = ""
		for zip in zInstallParts:
			zInstallPath = zInstallPath + zip + "\\"
		break

extensionsPath = zInstallPath + "Extensions"

for p in sys.path:
	if string.find(p, extensionsPath) != -1:
		extensionsFound = 1

if not extensionsFound:
	sys.path.append(extensionsPath)

import processHtml

PORT = 8578			#port for storagerIndexer

def writeDebugInfo(msg):
	debugFile = open("c:\\debug.txt", "a+")
	debugFile.write(msg)
	debugFile.close()
	return

def tracebackAsString(limit):
	type, value, tb = sys.exc_info()
	aList = traceback.format_exception(type, value, tb, limit)
	formattedString = ""
	for s in aList:
		formattedString = formattedString + s + "\n"
	return formattedString

def cache(self, REQUEST, RESPONSE, AUTHENTICATED_USER):
	#Zope external method. A lot of the code for this method was duplicated from
	#proxy() in proxy.py.
	authenticatedUserName = `AUTHENTICATED_USER`
	serverName = REQUEST["SERVER_NAME"]
	storageFolder = self.aq_parent["storageFolder"]
	mgDir = self.aq_parent["mgDir"]
	s = "Error retrieving page."

	queryString = REQUEST['QUERY_STRING']

	#get the base address and the url from the queryString
	if queryString:

		#fix problem with queryString being quoted sometimes which throws off everything
		queryString = urllib.unquote(queryString)

		#fix problem with CGI scripts adding their query string and additional "?'s" to our query
		#string which has base and url info. in it
		queryString = string.replace(queryString, "?", "&")

		#find the base address
		try:
			basePat = re.compile(r'k0olbase=(?P<base>[^&]*)', re.IGNORECASE | re.DOTALL)
			match = basePat.search(queryString)
			processHtml.origBaseUrl = match.group("base")
		except AttributeError, data:
			#for testing/debugging
			return "Can't find k0olbase in queryString: " + "\n\n" + `REQUEST`

		#find the url, which may be absolute or relative
		try:
			urlPat = re.compile(r'k0olurl=(?P<url>[^&]*)', re.IGNORECASE | re.DOTALL)
			match = urlPat.search(queryString)
			url = match.group("url")
		except AttributeError, data:
			#for testing/debugging
			return "Can't find k0olurl in queryString: " + "\n\n" + `REQUEST`

	#else queryString was blank; so get base address and url from the REQUEST
	else:
		processHtml.origBaseUrl = REQUEST['k0olbase']
		url = REQUEST['k0olurl']

	#determine the full/absolute url to open
	fullUrl = processHtml.constructAbsoluteUrl(url)

	#get the contents of the url
	try:
		#-----determine the new base URL from the current full URL-----

		processHtml.origBaseUrl = processHtml.getBaseUrlFromFullUrl(fullUrl)
	except Exception, data:
		return "Exception determining base URL--cache().\n"

	if fullUrl[:7] == "http://":
		siteUrl = fullUrl[7:]	#get rid of http://
	elif fullUrl[:8] == "https://":
		siteUrl = fullUrl[8:]	#get rid of https://

	writeDebugInfo("cache() siteUrl=" + siteUrl + "\n")

	#talk to storagerIndexer process to get correct cached page
	try:
		clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

		cacheRequest = ("retrieveFromCache" + "|"
						+ authenticatedUserName + "|"
						+ storageFolder + "|"
						+ siteUrl + "|"
						+ mgDir)

		clientsock.connect(serverName, PORT)
		clientsock.send(cacheRequest)
		s = clientsock.recv(204800) #200K
		clientsock.close()
	except Exception, data:
		writeDebugInfo("Error communicating with storager: " + `data` + "\n")
		try:
			clientsock.close()
		except:
			pass

	return s
